class StatesAndLgaResponse {
  List<States>? states;

  StatesAndLgaResponse({this.states});

  StatesAndLgaResponse.fromJson(Map<String, dynamic> json) {
    if (json['states'] != null) {
      states = <States>[];
      json['states'].forEach((v) {
        states!.add(new States.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    if (this.states != null) {
      data['states'] = this.states!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class States {
  String? country;
  String? state;
  String? shortcode;
  List<String>? localGovernments;

  States({this.country, this.state, this.shortcode, this.localGovernments});

  States.fromJson(Map<String, dynamic> json) {
    country = json['country'];
    state = json['state'];
    shortcode = json['shortcode'];
    localGovernments = json['localGovernments'].cast<String>();
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['country'] = this.country;
    data['state'] = this.state;
    data['shortcode'] = this.shortcode;
    data['localGovernments'] = this.localGovernments;
    return data;
  }
}
