// ignore_for_file: must_be_immutable

import 'package:flutter/material.dart';

import 'package:rothko_mobile/model/states_lga_model.dart';
import 'package:rothko_mobile/rothko.dart';

class RothkoStatesLGaSelect extends StatefulWidget {
  final List<String>? options;
  final BuildContext? context;
  final void Function(String?) onStateChanged;
  final void Function(String?) onLGAChanged;
  final String? selected;
  DropDownSize? size;
  final String? hintText;
  final Widget? suffixIcon;
  final String? labelText;
  final String? labelText2;
  final Color? labelTextColor;
  final String? Function(String)? validator;
  final String? Function(String?)? LgaValidator;
  final AutovalidateMode? autovalidateMode;
  bool? enabled;
  Function()? onTap;
  bool? readonly;
  double? spaceBetween;
  final double? labelTextSize, width;
  bool? focused;
  final BorderSide? customBorder;

  RothkoStatesLGaSelect(
      {this.options,
      this.context,
      required this.onStateChanged,
      required this.onLGAChanged,
      this.size,
      this.autovalidateMode,
      this.selected,
      this.hintText,
      this.focused = false,
      this.readonly = false,
      this.onTap,
      this.spaceBetween,
      this.LgaValidator,
      this.enabled = true,
      this.suffixIcon,
      this.labelText,
      this.labelText2,
      this.labelTextColor,
      this.validator,
      this.labelTextSize,
      this.customBorder,
      this.width});
  @override
  _RothkoStatesLGaSelectState createState() => _RothkoStatesLGaSelectState();
}

class _RothkoStatesLGaSelectState extends State<RothkoStatesLGaSelect> {
  FocusNode? _labelFocusNode;
  Color fillColor = kLightNeutralLighten5;
  String? selectedLga;
  List<String> selectedLGAList = [];
  States? selectedState;

  bool isFocused = false;
  @override
  void initState() {
    super.initState();
    _labelFocusNode = FocusNode();
    requestFocus();
    RothkoCache.fetchStates();
  }

  @override
  void dispose() {
    _labelFocusNode!.dispose();
    super.dispose();
  }

  void requestFocus() {
    if (widget.selected != null) {
      setState(() {
        isFocused = true;
        widget.focused = true;
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      width: MediaQuery.of(context).size.width * 0.9,
      padding: EdgeInsets.zero,
      child: Column(
        mainAxisSize: MainAxisSize.min,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          SelectDefaultDynamic<States>(
              options:
                  RothkoCache.statesAndLgaResponse?.states?.toSet().toList() ??
                      [],
              getText: (dynamic e) {
                return "${e.state ?? ""}";
              },
              hintText: '',
              onChanged: (dynamic val) {
                selectedLga = null;
                selectedLGAList.clear();
                RothkoCache.selectedState = val;

                selectedLGAList =
                    RothkoCache.selectedState?.localGovernments ?? [];

                setState(() {
                  selectedState = val;
                });
                widget.onStateChanged(val.state);
              },
              // validator: (v) => widget.validator?.call(v?.state ?? ""),
              selected: selectedState,
              labelText: widget.labelText ?? 'State'),
          SizedBox(height: widget.spaceBetween ?? 16),
          SelectDefaultDynamic<String>(
              options: selectedLGAList,
              getText: (dynamic e) {
                return "$e";
              },
              // validator: widget.LgaValidator,
              hintText: '',
              onChanged: (dynamic val) {
                selectedLga = val ?? "";
                setState(() {});
                widget.onStateChanged(val);
              },
              selected: selectedLga,
              labelText: widget.labelText2 ?? 'Local government'),
        ],
      ),
    );
  }
}
